DeclareModule Generator
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
 
  Declare.i HalbzugGenerator (*Quelle.BrettDaten, Array Halbzugspeicher.BrettDaten(1) )
  Declare.i SteineGegnerEntfernen (*Puffer.BrettDaten, Array Halbzugspeicher.BrettDaten(1), *SpeicherIndex.any, AnzahlZuEntf.i)
    
  ; von      steht fr die Position des Steines, der gezogen wird
  ; nach     steht fr das Ziel dieses Steines, also wohin bewegt sich "von"
  ; entf_a   steht fr einen entfernten Stein
  ; entf_b   steht fr einen weiteren entfernten Stein
  ; wenn ein Wert nicht gesetzt wird, ist dieser -1
  ; wenn von=-1 und nach>-1 entspricht dies einem Zug in der Setzphase
  ; ist entf_a=-1 wurde kein Stein des Gegners entfernt, es entstand keine Mhle  
  Structure ZugInfo
    von.i
    nach.i
    entf_a.i
    entf_b.i
  EndStructure
  
  Declare HoleZugInfo (*Quelle.BrettDaten, *Ziel.BrettDaten, *ZI.ZugInfo)
  
EndDeclareModule


Module Generator
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  
  ;folgende Funktion "befllt" einen HalbzugSpeicher mit allen mglichen Halbzgen jener Farbe die nun am Zug ist
  Procedure.i HalbzugGenerator (*Quelle.BrettDaten, Array Halbzugspeicher.BrettDaten(1) )
    Define.i Farbindex,Phase,SpeicherIndex,AnzahlMuehle,ZielPosition,UrsprungsPosition
    Define.l zielfrei
    Define.BrettDaten Puffer
    Farbindex=AktiverSpieler(*Quelle)
    Phase=AktuelleSpielPhase(*Quelle)
    
    SpeicherIndex=-1
  
    If Phase=1
    
      zielfrei=PositionenFrei(*Quelle)
        For ZielPosition =0 To 23
          If bit(zielfrei,ZielPosition)  ;wenn freie Position auf Brett gefunden
            
            CopyStructure(*Quelle, @Puffer, BrettDaten);komplettes *Quelle in Puffer kopieren
            Puffer\Halbzug =Puffer\Halbzug+1;in Puffer Halbzug erhhen
            Puffer\BF_Brett(FarbIndex)=bitset(Puffer\BF_Brett(FarbIndex),ZielPosition);in Puffer Stein setzen
  
            AnzahlMuehle=PositionInMuehle(@Puffer,ZielPosition)
            If AnzahlMuehle ;wenn gesetzter Stein Bestandteil einer Mhle ist...
              ;SpeicherIndex=SteineGegnerEntfernen(@Puffer,Halbzugspeicher() ,@Speicherindex, AnzahlMuehle)
              SteineGegnerEntfernen(@Puffer,Halbzugspeicher() ,@Speicherindex, AnzahlMuehle)
            Else                                                            ;wenn keine Mhle
              
              SpeicherIndex=SpeicherIndex+1                                 ;erhhen des Index auf nchste noch leere Speicherposition                         
              CopyStructure(@Puffer, Halbzugspeicher(SpeicherIndex), BrettDaten);Puffer dort hinein kopieren
            EndIf
  
          EndIf

        Next ZielPosition
      
    Else; Phase 2 u 3 / Schiebe- u. Springphase
    
        If Phase=3  
          zielfrei=PositionenFrei(*Quelle); Springphase, alle freien Positionen, braucht nur einmal ermittelt werden
        EndIf
        For UrsprungsPosition =0 To 23
          If bit(*Quelle\BF_Brett(FarbIndex),UrsprungsPosition)  ;wenn gesetzen Stein gefunden
            If Phase=2  
              zielfrei=NachbarFrei(*Quelle,UrsprungsPosition);Schiebephase, nur freie Positionen um UrsprungsPosition herum
            EndIf

            If zielfrei                                             ;wenn freie Positionen existieren(Feld dann >0)
              For ZielPosition =0 To 23                       
                If bit(zielfrei,ZielPosition)                       ;wenn freie ZielPosition gefunden
                  
                  CopyStructure(*Quelle, @Puffer, BrettDaten);komplettes *Quelle in Puffer kopieren
                  Puffer\Halbzug =Puffer\Halbzug+1;in Puffer Halbzug erhhen          
                  Puffer\BF_Brett(FarbIndex)=bitreset (Puffer\BF_Brett(FarbIndex),UrsprungsPosition);Stein von alter Position entfernen
                  Puffer\BF_Brett(FarbIndex)=bitset (Puffer\BF_Brett(FarbIndex),ZielPosition);Stein an neue Position setzen                
                  AnzahlMuehle=PositionInMuehle(@Puffer,ZielPosition)
                  If AnzahlMuehle ;wenn gesetzter Stein Bestandteil einer Mhle ist...
                    ;SpeicherIndex=SteineGegnerEntfernen(@Puffer,Halbzugspeicher() ,@Speicherindex, AnzahlMuehle)
                    SteineGegnerEntfernen(@Puffer,Halbzugspeicher() ,@Speicherindex, AnzahlMuehle)
                  Else                                                            ;wenn keine Mhle
                    SpeicherIndex=SpeicherIndex+1;erhhen des Index auf nchste noch leere Speicherposition                                
                    CopyStructure(@Puffer, Halbzugspeicher(SpeicherIndex), BrettDaten);Puffer dort hinein kopieren
                  EndIf
  
                EndIf
              Next ZielPosition
            EndIf
          EndIf
        Next UrsprungsPosition  
    EndIf
    ProcedureReturn SpeicherIndex+1;Rckgabewert=Anzahl der gefundenen Zge,darum +1
  EndProcedure
  
  
  ;Nach einer/zwei Mhle(n) reiht diese Funktion jeden herausgenommenen Stein (oder die 2er Kombination) des Gegners als eigene Brettsituation in den Halbzugspeicher ein
  Procedure.i SteineGegnerEntfernen (*Puffer.BrettDaten, Array Halbzugspeicher.BrettDaten(1), *SpeicherIndex.any, AnzahlZuEntf.i)
    Define.i Gegner,MerkeEntfPosition,EntfPosition,EntfPositionA,EntfPositionB,AnzahlSteineGegner
    Define.l entfgegner
    Gegner=AktiverSpieler(*Puffer);Farbindex des Gegners der dezimiert werden soll,basierend auf Puffer!!! 
    AnzahlSteineGegner=ZaehleBits(*Puffer\BF_Brett(Gegner))

    If AnzahlSteineGegner>0
    
      Select AnzahlZuEntf
                   
        Case 1; EIN Stein des Gegners entfernen (der "NORMALFALL"):
    
          ;Zuerst immer freie Steine des Gegners ermitteln
          entfgegner=SteineUngeschuetzt(*Puffer, Gegner)
          ;!!!Ausnahme!!! sollten alle Steine des Gegners in einer oder mehreren Mhlen stecken, so darf/muss man an die Geschtzten ran:
          If entfgegner=0  
            entfgegner=SteineGeschuetzt(*Puffer, Gegner)
          EndIf
          For EntfPosition =0 To 23
            If bit(entfgegner,EntfPosition) 
              *SpeicherIndex\i=*SpeicherIndex\i+1                                 ;erhhen des Index auf nchste noch leere Speicherposition
              CopyStructure(*Puffer, Halbzugspeicher(*SpeicherIndex\i), BrettDaten);Puffer dort hinein kopieren      
              Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner)=bitreset (Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner), EntfPosition);Stein des Gegners entfernen
            EndIf
          Next EntfPosition
    
        Case 2; ZWEI Steine des Gegners entfernen:
          ;hier wirds jetzt echt tricky, und dieser Fall kann eigentlich nur in der Setzphase auftreten, muss aber abgedeckt sein
          
          ;ein Beispiel:
          ;Halbzug 17 (Setzphase!) WEISS am Zug: wenn WEISS mit einem neuen Stein auf x setzt, werden dadurch zwei Mhlen geschlossen und auch zwei gegnerische Steine entfernt
          ;(ob die hier gezeigten Beispiele tatschlich so zustande kommen knnen... keine Ahnung)
          ;+-----W-----+      ;+-----W-----+      ;+-----W-----+
          ;| W---x---W |      ;| W---x---W |      ;| W---x---W |
          ;| | +-W-+ | |      ;| | +-W-+ | |      ;| | +-W-+ | |
          ;+-+-+   +-+-+      ;+-+-+   +-+-+      ;+-+-+   +-+-+
          ;| | +-+-+ | |      ;| | S-+-+ | |      ;| | +-+-+ | |
          ;| S---S---S |      ;| S---+---+ |      ;| S---S---S |
          ;S-----+-----+      ;S-----+-----+      ;+-----+-----+
          ;ein freier          beide frei          beide geschtzt
          ;ein geschtzter
          entfgegner=SteineUngeschuetzt(*Puffer, Gegner)
          
          If ZaehleBits(entfgegner)=1  ;wenn nur EIN freier gegnerischer Stein da ist
    
            ;freien gegnerischen Stein merken
            For EntfPosition =0 To 23
              If bit(entfgegner,EntfPosition)
                MerkeEntfPosition=EntfPosition
              EndIf
            Next EntfPosition
            ;wir kombinieren jetzt den gemerkten freien mit jedem geschtzten Stein, um die 2er Kombi zu erhalten...
            entfgegner=SteineGeschuetzt(*Puffer, Gegner);erstmal die  geschtzten Steine holen
            For EntfPosition =0 To 23
              If bit(entfgegner,EntfPosition) 
                *SpeicherIndex\i=*SpeicherIndex\i+1                                 ;erhhen des Index auf nchste noch leere Speicherposition
                CopyStructure(*Puffer, Halbzugspeicher(SpeicherIndex), BrettDaten);Puffer dort hinein kopieren      
                Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner)=bitreset (Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner), MerkeEntfPosition);freienStein des Gegners entfernen
                Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner)=bitreset (Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner), EntfPosition);Stein des Gegners entfernen
              EndIf
            Next EntfPosition
    
          Else; entweder alle beide zu entfernenden Steine sind frei, oder beide sind geschtzt!!
    
            If entfgegner=0
              entfgegner=SteineGeschuetzt(*Puffer, Gegner);wenn keine freien (oben ermittelt) dann eben die geschtzten, fertig :)
            EndIf
            ;oha Kombinatorik! aus x Elementen 2 heraussuchen, Reihenfolge der 2 Elemente egal, ohne Wiederholung/Dopplung.
            ;folgendes FOR..NEXT Konstrukt kombiniert jeden in der usseren Schleife gefundenen ersten Stein mit jedem seiner
            ;Nachfolger(innere Schleife)
            For EntfPositionA =0 To 22
              If bit(entfgegner,EntfPositionA) 
                For EntfPositionB =EntfPositionA+1 To 23
                  If bit(entfgegner,EntfPositionB) 
                    *SpeicherIndex\i=*SpeicherIndex\i+1                                 ;erhhen des Index auf nchste noch leere Speicherposition
                    CopyStructure(*Puffer, Halbzugspeicher(SpeicherIndex), BrettDaten);Puffer dort hinein kopieren   
                    Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner)=bitreset (Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner), EntfPositionA);ersten Stein des Gegners entfernen
                    Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner)=bitreset (Halbzugspeicher(*SpeicherIndex\i)\BF_Brett(Gegner), EntfPositionB);zweiten Stein des Gegners entfernen
                  EndIf
                Next EntfPositionB
              EndIf
            Next EntfPositionA
          EndIf
    
      EndSelect
    
    Else
    
      ;wenn denn doch nichts zu entfernen ist weil keine gegnerischen Steine nicht da... 
      ;das sollte nur beim Testen des Generators auftreten knnen...
      ;schliessen der Mhle, ohne Steine nehmen
      *SpeicherIndex\i=*SpeicherIndex\i+1                                 ;erhhen des Index auf nchste noch leere Speicherposition
      CopyStructure(*Puffer, Halbzugspeicher(*SpeicherIndex\i), BrettDaten);Puffer dort hinein kopieren      
        
    EndIf
    
    ProcedureReturn SpeicherIndex;fr Diagnosezwecke!! ist nicht notwendig, Wert wird BYREF bergeben und so verndert  
  EndProcedure
  


;da innerhalb des gesamten Spiels nur "fertige" Brettdaten berechnet/bergeben werden,
;hier nun die "Analyse-Funktion" ;): 
;die folgende Funktion liefert jene Positionen, welche sich bei zwei aufeinander folgenden (das ist wichtig) Brettsituationen gendert haben.
;allerdings habe ich darauf verzichtet, eine Prfung dieser Bedingung einzubauen.
;nichts miteinander zu tun habene Stellungen fhren dann zu entsprechenden Ergebnissen
  Procedure HoleZugInfo (*Quelle.BrettDaten, *Ziel.BrettDaten, *ZI.ZugInfo)
    With *ZI
      \von    =-1
      \nach   =-1
      \entf_a =-1
      \entf_b =-1
      Define.i aktiv, passiv, i
      aktiv=AktiverSpieler(*Quelle);der einen Zug macht um Stellung Ziel zu erreichen
      passiv=PassiverSpieler(*Quelle);der nichts macht, dem Steine genommen werden knnen
      For i =0 To 23
        If (bit(*Quelle\BF_Brett(aktiv),i)=1) And (bit(*Ziel\BF_Brett(aktiv),i)=0)  
          \von=i
        EndIf
        If (bit(*Quelle\BF_Brett(aktiv),i)=0) And (bit(*Ziel\BF_Brett(aktiv),i)=1)
          \nach=i
        EndIf
        ;bei zu entfernenden Steinen immer erst .entf_a setzen, entf_a stellt somit auch eine Art Indikator dar, ob eine Mhle entstanden ist oder nicht
        If \entf_a=-1 
          If (bit(*Quelle\BF_Brett(passiv),i)=1) And (bit(*Ziel\BF_Brett(passiv),i)=0)
            \entf_a=i
          EndIf
        Else
          If (bit(*Quelle\BF_Brett(passiv),i)=1) And (bit(*Ziel\BF_Brett(passiv),i)=0)
            \entf_b=i
          EndIf
        EndIf
      Next i
    EndWith
  EndProcedure
  
EndModule


; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 206
; FirstLine = 177
; Folding = -
; EnableXP