DeclareModule KI
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator
  
  Declare   BerechneZug          (*Quelle.Brettdaten, *Ziel.Brettdaten, *Bewertung.any, Tiefe.i=4, Variante.i=1)
  Declare.i MiniMax              (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
  Declare.i MiniMax_Maximierer   (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
  Declare.i MiniMax_Minimierer   (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
  Declare.i AlphaBeta            (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
  Declare.i AlphaBeta_Maximierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
  Declare.i AlphaBeta_Minimierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
EndDeclareModule


Module KI
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator

   Procedure BerechneZug (*Quelle.Brettdaten, *Ziel.Brettdaten, *Bewertung.any, Tiefe.i=4, Variante.i=1)
    
    Select Variante
      
      Case 1
        Minimax (*Quelle, *Ziel, Tiefe)
      
      Case 2
        If AktiverSpieler(*Quelle) 
          Minimax_Minimierer (*Quelle, *Ziel, Tiefe)
        Else  
          Minimax_Maximierer (*Quelle, *Ziel, Tiefe)
        EndIf
      
      Case 3
        AlphaBeta (*Quelle, *Ziel, Tiefe)
      
      Case 4
        If AktiverSpieler(*Quelle)
          AlphaBeta_Minimierer (*Quelle, *Ziel, Tiefe)
        Else
          AlphaBeta_Maximierer (*Quelle, *Ziel, Tiefe)
        EndIf
      
      Default
        Minimax (*Quelle, *Ziel, Tiefe)
    
    EndSelect

   EndProcedure
  
  
  ;MiniMax
  ;combined
  Procedure.i MiniMax (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
    Define.i Bewertung, AktuelleBewertung, BewertungWeiss, BewertungSchwarz
    Define.i AnzahlHZ, IndexHZ, SpielerIndex, BesterIndex
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1)
  
    AktuelleBewertung=BrettBewertung(*Quelle, Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
  
      Bewertung= AktuelleBewertung
      CopyStructure (*Quelle, *Ziel, Brettdaten)
  
    Else
  
      BewertungWeiss  =-1024
      BewertungSchwarz=1024
      SpielerIndex=AktiverSpieler(*Quelle)
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
      IndexHZ=0
      Repeat
  
        AktuelleBewertung=MiniMax (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1)
  
        If SpielerIndex
          If AktuelleBewertung < BewertungSchwarz
            BewertungSchwarz=AktuelleBewertung
            BesterIndex=IndexHZ
          EndIf
        Else
          If AktuelleBewertung > BewertungWeiss
            BewertungWeiss=AktuelleBewertung
            BesterIndex=IndexHZ
          EndIf
        EndIf
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ)
  
      If SpielerIndex
        Bewertung= BewertungSchwarz
      Else
        Bewertung= BewertungWeiss
      EndIf    
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
  
    EndIf
    ProcedureReturn Bewertung
  EndProcedure
  
  
  ;split
  Procedure.i MiniMax_Maximierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
    Define.i Bewertung, AktuelleBewertung
    Define.i AnzahlHZ, IndexHZ, BesterIndex
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1)    
  
    AktuelleBewertung=BrettBewertung(*Quelle, Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
  
      Bewertung= AktuelleBewertung
      CopyStructure (*Quelle, *Ziel, Brettdaten)
  
    Else
  
      Bewertung  =-1024
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
      IndexHZ=0
      Repeat
        AktuelleBewertung=MiniMax_Minimierer (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1)
        If AktuelleBewertung > Bewertung 
          Bewertung=AktuelleBewertung
          BesterIndex=IndexHZ
        EndIf
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ)
  
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
  
    EndIf
    ProcedureReturn Bewertung
  EndProcedure
  
  
  
  Procedure.i MiniMax_Minimierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i)
    Define.i Bewertung, AktuelleBewertung
    Define.i AnzahlHZ, IndexHZ, BesterIndex
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1)    
  
    AktuelleBewertung=BrettBewertung(*Quelle,Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
  
      Bewertung= AktuelleBewertung
      CopyStructure (*Quelle, *Ziel, Brettdaten)
  
    Else
  
      Bewertung  =1024
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
      IndexHZ=0
      Repeat
        AktuelleBewertung=MiniMax_Maximierer (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1)
        If AktuelleBewertung < Bewertung 
          Bewertung=AktuelleBewertung
          BesterIndex=IndexHZ
        EndIf
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ)
  
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
  
    EndIf
    ProcedureReturn Bewertung
  EndProcedure
  
  
  ;AlphaBeta
  ;combined
  Procedure.i AlphaBeta (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
    Define.i Bewertung, AktuelleBewertung, BewertungWeiss, BewertungSchwarz
    Define.i AnzahlHZ, IndexHZ, SpielerIndex, BesterIndex, AlphaBetaAbbruch
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1) 
    
    SpielerIndex=AktiverSpieler(*Quelle)
  
    AktuelleBewertung=BrettBewertung(*Quelle, Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
        
        If SpielerIndex  ;1 -> Schwarz -> Minimierer
          BetaWert=AktuelleBewertung
        Else                 ;0 -> Weiss -> Maximierer
          AlphaWert=AktuelleBewertung
        EndIf
        
        Bewertung= AktuelleBewertung
        CopyStructure (*Quelle, *Ziel, Brettdaten)
  
    Else
  
      BewertungWeiss  =AlphaWert
      BewertungSchwarz=BetaWert
      AlphaBetaAbbruch=0
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
  
      IndexHZ=0
      Repeat
  
        AktuelleBewertung=AlphaBeta (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1, Alphawert, BetaWert)
  
        If SpielerIndex  ;1 -> Schwarz -> Minimierer
  
          If AktuelleBewertung < BewertungSchwarz 
            BewertungSchwarz=AktuelleBewertung
            BesterIndex=IndexHZ
            Betawert=BewertungSchwarz
            If BetaWert<=AlphaWert 
              AlphaBetaAbbruch=1
            EndIf
          EndIf
  
        Else                 ;0 -> Weiss -> Maximierer
  
          If AktuelleBewertung > BewertungWeiss 
            BewertungWeiss=AktuelleBewertung
            BesterIndex=IndexHZ
            Alphawert=BewertungWeiss
            If AlphaWert>=BetaWert
              AlphaBetaAbbruch=1
            EndIf
          EndIf
  
        EndIf
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ) Or (AlphaBetaAbbruch=1)
  
      If SpielerIndex
        Bewertung= BewertungSchwarz
      Else 
        Bewertung= BewertungWeiss
      EndIf
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
      
    EndIf
    ProcedureReturn Bewertung
  EndProcedure
  
  
  ;split
  Procedure.i AlphaBeta_Maximierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
    Define.i Bewertung, AktuelleBewertung
    Define.i AnzahlHZ, IndexHZ, BesterIndex, AlphaBetaAbbruch
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1)     
      
    AktuelleBewertung=BrettBewertung(*Quelle,Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
      
      Bewertung=AktuelleBewertung
      CopyStructure (*Quelle, *Ziel, Brettdaten)
  
    Else
  
      Bewertung=AlphaWert
      AlphaBetaAbbruch=0
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
  
      IndexHZ=0
      Repeat
  
        AktuelleBewertung=AlphaBeta_Minimierer (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1, Alphawert, BetaWert)
        If AktuelleBewertung > Bewertung 
          Bewertung=AktuelleBewertung
          BesterIndex=IndexHZ
          Alphawert=Bewertung
          If AlphaWert>=BetaWert
            AlphaBetaAbbruch=1
          EndIf
        EndIf
  
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ) Or (AlphaBetaAbbruch=1)
  
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
  
    EndIf
    ProcedureReturn Bewertung
  EndProcedure
  
   
  Procedure.i AlphaBeta_Minimierer (*Quelle.Brettdaten, *Ziel.Brettdaten, Tiefe.i, AlphaWert.i=-2048, BetaWert.i=2048)
    Define.i Bewertung, AktuelleBewertung
    Define.i AnzahlHZ, IndexHZ, BesterIndex, AlphaBetaAbbruch
    Dim Halbzugspeicher.Brettdaten(#ZugSpeicherGroesse-1)     
 
    AktuelleBewertung=BrettBewertung(*Quelle,Tiefe)
    If (Abs(AktuelleBewertung)>1023) Or (Tiefe<1) ;falls das bergebene Brett eine Finalstellung ist ODER die Suchtiefe erreicht, dann...
      
      Bewertung=AktuelleBewertung
      CopyStructure (*Quelle, *Ziel, Brettdaten)
    
    Else
  
      Bewertung=BetaWert
      AlphaBetaAbbruch=0
      BesterIndex=0
  
      AnzahlHZ=HalbzugGenerator (*Quelle, Halbzugspeicher() );Erzeugt Halbzge und gibt Anzahl der Gefundenen zurck
  
      IndexHZ=0
      Repeat
  
        AktuelleBewertung=AlphaBeta_Maximierer (@Halbzugspeicher(IndexHZ), *Ziel, Tiefe-1, Alphawert, BetaWert)
        If AktuelleBewertung < Bewertung 
          Bewertung=AktuelleBewertung
          BesterIndex=IndexHZ
          Betawert=Bewertung
          If BetaWert<=AlphaWert
            AlphaBetaAbbruch=1
          EndIf
        EndIf
  
        IndexHZ =IndexHZ+1
      Until (IndexHZ=AnzahlHZ) Or (AlphaBetaAbbruch=1)
  
      CopyStructure (@Halbzugspeicher(BesterIndex), *Ziel, Brettdaten)
    EndIf
    
    ProcedureReturn Bewertung
  EndProcedure

EndModule

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 293
; FirstLine = 304
; Folding = --
; EnableXP