; ***** SpielStatus
; 0=keine Aktionen/Spielabbruch/Spielende
; 1=Zugvorbereitung
; 2=Selektiere Stein / Setze Stein  je nach MenschSpielPhase
; 3=Setze Stein                     nur in Schiebe- u. Springphase
; 4=Entferne gegnerischen Stein
; 5=Entferne zweiten gegnerischen Stein, wenn es denn so sein sollte
; 6=Zug Mensch "fertig bauen" in Quelle
; 7=KI aufrufen

DeclareModule SpielAblauf
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator
  UseModule KI
  UseModule TextGrafikOutput
  
  Structure MuehleSpiel
    SpielStatus.i             ;siehe oben
    Quelle.Brettdaten         ;Ausgangsbrett fr KI/ Mensch bzw. vollendeter Zug, egal ob Mensch oder Maschine  
  
    KITiefe.i                 ;durch die GUI voreingestellte Suchtiefe der KI
    KIVariante.i              ;von KI benutzter Suchalgo
    KIFarbe.i                 ;Spielfarbe der KI    
    KIZiel.Brettdaten         ;von KI fertig berechneter Zug als Stellung, wird spter nach Quelle kopiert
    KIBewertung.i             ;Bewertung des Zuges der KI in KIZiel
    KIZInfo.ZugInfo           ;aufbereiteter Zug der KI, also "Differenz" zwischen Quelle<->KIZiel
      
    MenschFarbe.i                                             ;Spielfarbe des Menschen
    MenschSpielPhase.i                                        ;SpielPhase des Menschen
    MenschZiel.Brettdaten                                     ;fertig gesetzter Zug des Menschen
    MenschZInfo.ZugInfo                                       ;aufbereiteter Zug des Menschen, also "Differenz" zwischen Quelle<->MenschZiel
    ;Zugregelwchter fr Mensch
    ;der selbe Zuggenerator, der das auch fr die KI tut, berechnet alle mglichen Zge des Menschen
    ;und hlt sie in einem Array.
    ;Der vom Menschen "zusammengeklickte" Zug muss dann "nur" noch mit einem vom Generator
    ;bereinstimmen.
    MenschAnzahlStellungen.i                                    ;enthlt Anzahl mglicher Zge des Menschen
    Array MenschStellungen.Brettdaten (#ZugSpeicherGroesse-1)   ;enthlt alle mglichen Stellungen die der Mensch "machen" kann
    Array MenschStellungenZInfo.ZugInfo (#ZugSpeicherGroesse-1) ;enthlt die Aufbereitungen dieser Stellungen
  EndStructure
  
  Declare SpielStart                  (*Spiel.Muehlespiel, KIs.i=0, KIt.i=4, KIv.i=2)
  Declare ZugVorbereitungMensch       (*Spiel.Muehlespiel)
  Declare SteinWaehlen                (*Spiel.Muehlespiel, KlickPosition.i)  ;in Zug u. Springphase von setzen / in Setzphase wird SteinSetzen() aufgerufen
  Declare SteinSetzen                 (*Spiel.Muehlespiel, KlickPosition.i)  ;in Zug u. Springphase nach setzen
  Declare Entfernen                   (*Spiel.Muehlespiel, KlickPosition.i)
  Declare EntfernenZwei               (*Spiel.Muehlespiel, KlickPosition.i)
  Declare ZugBeendenMensch            (*Spiel.Muehlespiel)
  Declare ZugKI                       (*Spiel.Muehlespiel)
  Declare AktualisiereMenschZiel (*Spiel.Muehlespiel)
  Declare SetzeFarbe                  (*Spiel.Muehlespiel, KlickPosition.i, Farbe.i)
EndDeclareModule


Module SpielAblauf
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator
  UseModule KI
  UseModule TextGrafikOutput
  
  Procedure SpielStart(*Spiel.Muehlespiel, KIs.i=0, KIt.i=4, KIv.i=2)
    With *Spiel
      ;Startbrett initiieren
      \Quelle\Halbzug=0
      \Quelle\BF_Brett(0)=0
      \Quelle\BF_Brett(1)=0
    
      ;Farbe den Spielern erstmal einfach fest zuweisen
      \MenschFarbe=0
      \KIFarbe=1
      ;falls KI beginnen soll dann tauschen
      If KIs 
        Swap \MenschFarbe,\KIFarbe
      EndIf
;       Debug \MenschFarbe
;       Debug \KIFarbe
      
      ;KI konfigurieren
      \KITiefe=KIt
      \KIVariante=KIv
    
      If KIs;ruft in einem usseren Loop die KI auf, sofern diese beginnen soll, oder leitet den Zug des Menschen ein 
        \SpielStatus=7
      Else 
        \SpielStatus=1
      EndIf 

      ZeichneBrett (0,@\Quelle)
     
    EndWith
    ;Debug "Ende SpielStart"
  EndProcedure
  
  
  Procedure ZugVorbereitungMensch(*Spiel.Muehlespiel)
    Define.i i
    With *Spiel
      \MenschAnzahlStellungen=HalbzugGenerator ( @\Quelle, \MenschStellungen() ) ;erzeugt alle mglichen Zge die der Mensch machen kann
      ;gefundene Stellungen aufbereiten
      For i=0 To \MenschAnzahlStellungen-1
        HoleZugInfo (@\Quelle, @\MenschStellungen(i), @\MenschStellungenZInfo(i))
      Next i
      \SpielStatus=2
      \MenschZInfo\von=-1
      \MenschZInfo\nach=-1
      \MenschZInfo\entf_a=-1
      \MenschZInfo\entf_b=-1
      AktualisiereMenschZiel(*Spiel)
      
    EndWith
    ;Debug "Ende ZugVorbereitung"
  EndProcedure
  
  
  Procedure SteinWaehlen (*Spiel.Muehlespiel, KlickPosition.i)
    With *Spiel
      If AktuelleSpielPhase(\Quelle)<>1 ;wenn Zug oder Springphase
        ;jeder "menschliche" Stein darf erstmal selektiert werden, egal ob ein Zug mit diesem mglich oder nicht
        If bit(\Quelle\BF_Brett(\MenschFarbe), KlickPosition)
          \MenschZInfo\von=KlickPosition
          \SpielStatus=3
        Else
          \SpielStatus=2
        EndIf
        AktualisiereMenschZiel (*Spiel)
        AnimWahl (0, @\Quelle, KlickPosition)
      Else;wenn Setzphase
        ;dann schleifen wir den Klick einfach durch und rufen hier direkt und ohne SpielStatusnderung Steinsetzen() auf
        \MenschZInfo\von=-1
        SteinSetzen (*Spiel, KlickPosition)
      EndIf
    EndWith
    ;Debug "Ende SteinWaehlen" 
  EndProcedure
  
  
  Procedure SteinSetzen (*Spiel.Muehlespiel, KlickPosition.i)
    Define.i StellungsZaehler,gefunden
    With  *Spiel
      If bit(\Quelle\BF_Brett(\MenschFarbe),KlickPosition)=0
        StellungsZaehler=0
        gefunden=-1
        Repeat
          If (\MenschZInfo\von = \MenschStellungenZInfo(StellungsZaehler)\von) And (\MenschStellungenZInfo(StellungsZaehler)\nach=KlickPosition) 
           \MenschZInfo\nach=KlickPosition
           gefunden=StellungsZaehler
          EndIf
          StellungsZaehler=StellungsZaehler+1
        Until (gefunden>-1) Or StellungsZaehler=\MenschAnzahlStellungen
    
        If gefunden>-1 ;wenn ein Zug gefunden wurde
          If \MenschStellungenZInfo(gefunden)\entf_a > -1 ;sollte in der Stellung(gefunden) eine Mhle entstanden sein, dann ist auch das entsprechende \entf_a > -1
            \SpielStatus=4    ;Stein entfernen
          Else                ;keine Mhle
            \SpielStatus=6    ;Zug beenden
          EndIf
          AktualisiereMenschZiel (*Spiel)
          AnimZiehen (0, @\Quelle, @\MenschZiel, \MenschZInfo\von, \MenschZInfo\nach)
        Else                        ;wenn KEIN Zug gefunden wurde
          \MenschZInfo\von=-1       ;gemerkte Position lschen
          \MenschZInfo\nach=-1      ;gemerkte Position lschen, der sollte dann noch garnicht gendert worden sein egal :)
          \SpielStatus=2            ;zurck zu SteinWaehlen ()
          AktualisiereMenschZiel (*Spiel)
        EndIf
    
      EndIf
    EndWith
    ;Debug "Ende SteinSetzen"
  EndProcedure
  
  
  Procedure Entfernen (*Spiel.Muehlespiel, KlickPosition.i)
   Define.i StellungsZaehler,gefunden
    With *spiel
      If bit(\Quelle\BF_Brett(\KIFarbe),KlickPosition) 
        StellungsZaehler=0
        gefunden=-1
        Repeat
          If (\MenschZInfo\von = \MenschStellungenZInfo(StellungsZaehler)\von) And (\MenschZInfo\nach = \MenschStellungenZInfo(StellungsZaehler)\nach) ;wenn menschl. Zug gefunden
            If (\MenschStellungenZInfo(StellungsZaehler)\entf_a = KlickPosition)  ;wenn angeklickter KI Stein als entfernbar gefunden
              gefunden=StellungsZaehler
              \MenschZInfo\entf_a=KlickPosition
            EndIf
          EndIf
          StellungsZaehler=StellungsZaehler+1
        Until (gefunden>-1) Or StellungsZaehler=\MenschAnzahlStellungen
    
    
        If gefunden>-1                ;wenn entfernbarer Stein gefunden
          If \MenschStellungenZInfo(gefunden)\entf_b=-1 ;wenn es KEINEN zweiten Stein zum Entfernen gibt
            \SpielStatus=6            ;Zug beenden
          Else                        ;es gibt doch einen zweiten entfernbaren Stein
            \SpielStatus=5            ;SteinEntfernenZwei() aufrufen
          EndIf
        Else                          ;wenn kein entfernbarer Stein gefunden
          \SpielStatus=4              ;nochmals Entfernen() aufrufen
                                      ;bedeutet Entfernzwang, Steinsetzen() hat festgestellt da es was zum
                                      ;Entfernen gibt. Darum sind wir berhaupt erst hier gelandet :)
                                      ;solang kein entfernbarer Stein angeklickt wurde "verbleiben" wir hier
        EndIf
        AktualisiereMenschZiel (*Spiel)
        AnimEntfernen (0, @\Quelle, @\MenschZiel, \MenschZInfo\entf_a)
      EndIf
    EndWith
    ;Debug "Ende Entfernen"
  EndProcedure
  
  
  Procedure EntfernenZwei (*Spiel.Muehlespiel,KlickPosition.i)
   Define.i StellungsZaehler,gefunden
   With *Spiel
      If bit(\Quelle\BF_Brett(\KIFarbe),KlickPosition) 
        StellungsZaehler=0
        gefunden=-1
        Repeat
          If (\MenschZInfo\von = \MenschStellungenZInfo(StellungsZaehler)\von) And (\MenschZInfo\nach = \MenschStellungenZInfo(StellungsZaehler)\nach) And (\MenschZInfo\entf_b = \MenschStellungenZInfo(StellungsZaehler)\entf_b) ;wenn Stellung menschl. Zug  und ersten entfernbaren Stein gefunden
            If (\MenschStellungenZInfo(StellungsZaehler)\entf_b = KlickPosition)  ;wenn angeklickter KI Stein als entfernbar gefunden
              gefunden=StellungsZaehler
              \MenschZInfo\entf_b=KlickPosition
            EndIf
          EndIf
          StellungsZaehler=StellungsZaehler+1
        Until (gefunden>-1) Or StellungsZaehler=\MenschAnzahlStellungen
    
        If gefunden>-1                                  ;wenn entfernbarer Stein gefunden
          \SpielStatus=6                                ;Zug beenden
        Else                                            ;wenn kein entfernbarer Stein gefunden
          \MenschZInfo\entf_b=-1
          \MenschZInfo\entf_b=-1
          \SpielStatus=4                                ;nochmals Entfernen() aufrufen
        EndIf
        AktualisiereMenschZiel (*Spiel)
        AnimEntfernen (0, @\Quelle, @\MenschZiel, \MenschZInfo\entf_b)
      EndIf
    EndWith
    ;Debug "Ende EntfernenZwei"
  EndProcedure
  
  
  Procedure ZugBeendenMensch (*Spiel.Muehlespiel)
    With *Spiel
      CopyStructure(@\MenschZiel, @\Quelle, BrettDaten)
      
;       Debug Str(\Quelle\HalbZug) + ":"
;       Debug RSet(Bin(\Quelle\BF_Brett(0)), 32, "0")            + "  weiss"
;       Debug RSet(Bin(\Quelle\BF_Brett(1)), 32, "0")            + "  schwarz"       
      
      \SpielStatus=7
    EndWith
    ;Debug "Ende ZugBeendenMensch"    
  EndProcedure
  
  
  Procedure ZugKI (*Spiel.Muehlespiel)
    With *Spiel
      BerechneZug (@\Quelle, @\KIZiel, @\KIBewertung, \KITiefe, \KIvariante)      
      HoleZugInfo(@\Quelle, @\KIZiel, @\KIZInfo)

      AnimZiehen (0, @\Quelle, @\KIZiel, \KIZInfo\von, \KIZInfo\nach)
      If \KIZInfo\entf_b>-1  
        AnimEntfernen (0, @\Quelle, @\KIZiel, \KIZInfo\entf_a, \KIZInfo\entf_b)
      EndIf
      
      CopyStructure(@\KIZiel, @\Quelle, BrettDaten)
      
;       Debug Str(\Quelle\HalbZug) + ":"
;       Debug RSet(Bin(\Quelle\BF_Brett(0)), 32, "0")            + "  weiss"
;       Debug RSet(Bin(\Quelle\BF_Brett(1)), 32, "0")            + "  schwarz"
            
      ZeichneBrett (0, @\Quelle)      
      \SpielStatus=1;leitet den Zug des Menschen ein
    EndWith
    ;Debug "Ende ZugKI"
  EndProcedure
  
  
  Procedure AktualisiereMenschZiel (*Spiel.Muehlespiel)
    With *Spiel
      CopyStructure(@\Quelle, @\MenschZiel, BrettDaten)
      \MenschZiel\Halbzug=\MenschZiel\Halbzug+1
      If \MenschZInfo\von>-1 
        \MenschZiel\BF_Brett(\MenschFarbe)=bitreset(\MenschZiel\BF_Brett(\MenschFarbe),\MenschZInfo\von)
      EndIf
      If \MenschZInfo\nach>-1
        \MenschZiel\BF_Brett(\MenschFarbe)=bitset(\MenschZiel\BF_Brett(\MenschFarbe),\MenschZInfo\nach)
      EndIf
      If \MenschZInfo\entf_a>-1
        \MenschZiel\BF_Brett(\KIFarbe)    =bitreset(\MenschZiel\BF_Brett(\KIFarbe),\MenschZInfo\entf_a)
      EndIf
      If \MenschZInfo\entf_b>-1
        \MenschZiel\BF_Brett(\KIFarbe)    =bitreset(\MenschZiel\BF_Brett(\KIFarbe),\MenschZInfo\entf_b)
      EndIf
    EndWith
  EndProcedure
  
    
  Procedure SetzeFarbe (*Spiel.Muehlespiel, KlickPosition.i, Farbe.i)
    With *Spiel
      Select Farbe
        Case 0
          \Quelle\BF_Brett(0)= bitset( \Quelle\BF_Brett(0),KlickPosition)
          \Quelle\BF_Brett(1)= bitreset( \Quelle\BF_Brett(1),KlickPosition)
        Case 1
          \Quelle\BF_Brett(0)= bitreset( \Quelle\BF_Brett(0),KlickPosition)
          \Quelle\BF_Brett(1)= bitset( \Quelle\BF_Brett(1),KlickPosition)
        Case 2
          \Quelle\BF_Brett(0)= bitreset( \Quelle\BF_Brett(0),KlickPosition)
          \Quelle\BF_Brett(1)= bitreset( \Quelle\BF_Brett(1),KlickPosition)
      EndSelect
    EndWith
  EndProcedure
EndModule

; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 248
; FirstLine = 237
; Folding = ---
; EnableXP
; DisableDebugger