﻿DeclareModule TextGrafikOutput
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator
  UseModule KI
  
  ;*******************************************************************************
  ;*******************************************************************************
  ;GUI Text Ausgabe***************************************************************
  Global Dim AusgabeMuster.s(6)
  Global Dim TAzugriff.i(23,1)

  Structure gfxboardposition
    x.i
    y.i
  EndStructure
  
  ;*******************************************************************************
  ;*******************************************************************************
  ;Brett GFX Positionen und Mausklick aufs Brett**********************************  
  Global Dim Board.gfxboardposition(23)
  Global stretch.i
  
  Declare BrettZuText(*QuellBrett.Brettdaten, Array textarray.s(1) )
  Declare ZeichneNurBrett ()
  Declare ZeichneNurSteine (*Quelle.Brettdaten, PosA.i=-1, PosB.i=-1) 
  Declare AnimierterStein(Farbe.i, von.i=-1, nach.i=-1, Prozent.f=0)
  Declare ZeichneBrett (DrawOutputID.i,*Quelle.Brettdaten)    
  Declare AnimZiehen    (DrawOutputID.i,*Quelle.Brettdaten, *Ziel.Brettdaten, von.i=-1, nach.i=-1, Dauer.f=1000)
  Declare AnimEntfernen (DrawOutputID.i,*Quelle.Brettdaten, *Ziel.Brettdaten, EntfA.i=-1, EntfB.i=-1, Dauer.f=1000)
  Declare AnimWahl      (DrawOutputID.i,*Quelle.Brettdaten, Wahl.i, Dauer.f=1000)
EndDeclareModule


Module TextGrafikOutput
  UseModule Portierung
  UseModule BrettStruktur
  UseModule Brett  
  UseModule Generator
  UseModule KI
  
  Define.s csvzeile
  Define.i i
  If ReadFile(0,"dat\AusgabeText.csv") 
    ;Header weglesen
      csvzeile = ReadString(0)
    For i=0 To 6
      AusgabeMuster(i)= ReadString(0)
    Next i
    CloseFile(0)
  Else
    MessageRequester("Warn", "AusgabeText.csv", #PB_MessageRequester_Ok)
  EndIf
  
  If ReadFile(0,"dat\AusgabeTextZugriff.csv") 
    ;Header weglesen
      csvzeile = ReadString(0)
    For i=0 To 23
      csvzeile = ReadString(0)
      TAzugriff(i,0)  =Val( StringField(csvzeile, 1, ",") )
      TAzugriff(i,1)  =Val( StringField(csvzeile, 2, ",") )
    Next i
    CloseFile(0)
  Else
    MessageRequester("Warn", "AusgabeTextZugriff.csv", #PB_MessageRequester_Ok)
  EndIf
  
  stretch=50;Streckt das Brett
  
  If ReadFile(0,"dat\GFXBrettPositionen.csv") 
    ;Header weglesen
      csvzeile = ReadString(0)
    For i=0 To 23
      csvzeile = ReadString(0)
      Board(i)\x  =Val( StringField(csvzeile, 1, ",") )
      Board(i)\y  =Val( StringField(csvzeile, 2, ",") )
      Board(i)\x  =Board(i)\x * stretch
      Board(i)\y  =Board(i)\y * stretch
    Next i
    CloseFile(0)
  Else
    MessageRequester("Warn", "GFXBrettPositionen.csv", #PB_MessageRequester_Ok)
  EndIf
  

  Procedure BrettZuText(*QuellBrett.Brettdaten, Array textarray.s(1) )
    Define i.i, zeile.i, spalte.i
    For i=0 To 6
      textarray(i)=AusgabeMuster(i)
    Next i
    For i=0 To 23
      zeile=TAzugriff(i,0)
      spalte=TAzugriff(i,1)*2;funzt nur mit "*2"! Unicode??? keine Ahnung, wirds wohl sein    
    
      If bit( *QuellBrett\BF_Brett(0),i)
        PokeA (@textarray(zeile) + spalte, Asc("W"))
      ElseIf bit( *QuellBrett\BF_Brett(1),i)
        PokeA (@textarray(zeile) + spalte, Asc("S"))
      Else
        PokeA (@textarray(zeile) + spalte, Asc("+"))
      EndIf
    Next i
  EndProcedure


  ;ohne StartDrawing()/StopDrawing()*********************************************
  ;******************************************************************************
  ;******************************************************************************
  
  Procedure ZeichneNurBrett ()
    ;Holz
    DrawingMode(#PB_2DDrawing_Default) 
    Box(Board(0)\x-stretch, Board(0)\y-stretch, stretch*8, stretch*8, RGB(255,100,0))
    ;Linien
    DrawingMode(#PB_2DDrawing_Outlined)
  
    LineXY( Board(0)\x , Board(0)\y , Board(2)\x , Board(2)\y , RGB(255,255,255) )
    LineXY( Board(2)\x , Board(2)\y , Board(4)\x , Board(4)\y , RGB(255,255,255) )
    LineXY( Board(4)\x , Board(4)\y , Board(6)\x , Board(6)\y , RGB(255,255,255) )
    LineXY( Board(6)\x , Board(6)\y , Board(0)\x , Board(0)\y , RGB(255,255,255) )
     
    LineXY( Board(8)\x , Board(8)\y , Board(10)\x , Board(10)\y , RGB(255,255,255) )
    LineXY( Board(10)\x , Board(10)\y , Board(12)\x , Board(12)\y , RGB(255,255,255) )
    LineXY( Board(12)\x , Board(12)\y , Board(14)\x , Board(14)\y , RGB(255,255,255) )
    LineXY( Board(14)\x , Board(14)\y , Board(8)\x , Board(8)\y , RGB(255,255,255) )  
    
    LineXY( Board(16)\x , Board(16)\y , Board(18)\x , Board(18)\y , RGB(255,255,255) )
    LineXY( Board(18)\x , Board(18)\y , Board(20)\x , Board(20)\y , RGB(255,255,255) )
    LineXY( Board(20)\x , Board(20)\y , Board(22)\x , Board(22)\y , RGB(255,255,255) )
    LineXY( Board(22)\x , Board(22)\y , Board(16)\x , Board(16)\y , RGB(255,255,255) )  
    
    LineXY( Board(1)\x , Board(1)\y , Board(17)\x , Board(17)\y , RGB(255,255,255) )
    LineXY( Board(3)\x , Board(3)\y , Board(19)\x , Board(19)\y , RGB(255,255,255) )
    LineXY( Board(5)\x , Board(5)\y , Board(21)\x , Board(21)\y , RGB(255,255,255) )
    LineXY( Board(7)\x , Board(7)\y , Board(23)\x , Board(23)\y , RGB(255,255,255) )
  EndProcedure
  
  
  ;optional: wenn PosA u. PosB >1, also als Brettposition klar definiert sind,
  ;dann werden diese Positionen NICHT gezeichnet.  Für Anim eines Steines zwischen PosA u. PosB
  Procedure ZeichneNurSteine (*Quelle.Brettdaten, PosA.i=-1, PosB.i=-1)
    Define i.i
    DrawingMode(#PB_2DDrawing_Default) 
    For i=0 To 23
      If (i<>PosA) And (i<>PosB)
        If bit(*Quelle\BF_Brett(0),i)
          Circle(Board(i)\x, Board(i)\y, 17, RGB(255,255,255))
        EndIf
        If bit(*Quelle\BF_Brett(1),i)
          Circle(Board(i)\x, Board(i)\y, 17, RGB(0,0,0))
        EndIf
      EndIf
    Next i
  EndProcedure
  
  
  ;berechnet die prozentual die Position eines Steines zwischen Start-(=0) bis Zielpunkt(=1)
  Procedure AnimierterStein(Farbe.i, von.i=-1, nach.i=-1, Prozent.f=0)
    Define.i vx,vy,nx,ny
    Define.f deltax,deltay
    Define.i col
    If Farbe=0
      col=RGB(255,255,255)
    Else
      col=RGB(0,0,0)
    EndIf
    
      If von=-1
      vx=15
      vy=15
    Else
      vx=Board(von)\x
      vy=Board(von)\y 
    EndIf
    If nach=-1
      nx=15
      ny=15
    Else
      nx=Board(nach)\x
      ny=Board(nach)\y
    EndIf
  
    If Prozent>1
      Prozent=1
    EndIf
    
    deltax=nx-vx
    deltay=ny-vy
    
    DrawingMode(#PB_2DDrawing_Default) 
    Circle(vx + deltax*Prozent, vy + deltay*Prozent,15,col)
  EndProcedure
  
  
  ;mit StartDrawing()/StopDrawing()**********************************************
  ;******************************************************************************
  ;******************************************************************************
  
  Procedure ZeichneBrett (DrawOutputID.i,*Quelle.Brettdaten)    
    If StartDrawing(CanvasOutput(DrawOutputID))
      ZeichneNurBrett ()
      ZeichneNurSteine (*Quelle)
    StopDrawing()
    EndIf 
  EndProcedure  
  
  
  Procedure AnimZiehen (DrawOutputID.i,*Quelle.Brettdaten, *Ziel.Brettdaten, von.i=-1, nach.i=-1, Dauer.f=1000)
    Define.f AnimStart,AnimEnde
    AnimStart=ElapsedMilliseconds()
    AnimEnde=AnimStart + Dauer
    Repeat
      StartDrawing(CanvasOutput(DrawOutputID))
        ZeichneNurBrett()
        ZeichneNurSteine (*Quelle,von,nach)
        AnimierterStein(AktiverSpieler(*Quelle), von, nach, (ElapsedMilliseconds()-AnimStart)/Dauer)
      StopDrawing()
    Until ElapsedMilliseconds()>AnimEnde
    
    StartDrawing(CanvasOutput(DrawOutputID))
      ZeichneNurBrett ()
      ZeichneNurSteine (*Ziel)
    StopDrawing()  
  EndProcedure
  
  
  Procedure AnimEntfernen (DrawOutputID.i,*Quelle.Brettdaten, *Ziel.Brettdaten, EntfA.i=-1, EntfB.i=-1, Dauer.f=1000)
    Define.f AnimStart,AnimEnde,InAnim
    AnimStart=ElapsedMilliseconds()
    AnimEnde=AnimStart + Dauer
    Repeat
      StartDrawing(CanvasOutput(DrawOutputID))
        ZeichneNurBrett ()
        ZeichneNurSteine (*Ziel,EntfA,EntfB)
        InAnim=ElapsedMilliseconds()
        If EntfA>-1
          AnimierterStein(PassiverSpieler(*Quelle), EntfA, -1, (InAnim-AnimStart)/Dauer)
        EndIf
        If EntfB>-1
          AnimierterStein(PassiverSpieler(*Quelle), EntfB, -1, (InAnim-AnimStart)/Dauer)
        EndIf
      StopDrawing()
    Until ElapsedMilliseconds()>AnimEnde
    
    StartDrawing(CanvasOutput(DrawOutputID))
      ZeichneNurBrett ()
      ZeichneNurSteine (*Ziel)
    StopDrawing()
  EndProcedure
  
  
  Procedure AnimWahl (DrawOutputID.i,*Quelle.Brettdaten, Wahl.i, Dauer.f=1000)
    Define.f AnimStart,AnimEnde
    AnimStart=ElapsedMilliseconds()
    AnimEnde=AnimStart + Dauer
    
    StartDrawing(CanvasOutput(DrawOutputID))
      ZeichneNurBrett()
    StopDrawing()
       
    If wahl>-1
      Repeat
        
        StartDrawing(CanvasOutput(DrawOutputID))
          ZeichneNurSteine (*Quelle)
          Circle(Board(Wahl)\x, Board(Wahl)\y, 9, RGB(0,200,0))
        StopDrawing()
        
        Delay (150)
        
        StartDrawing(CanvasOutput(DrawOutputID))
          ZeichneNurSteine (*Quelle)
        StopDrawing()
        
        Delay (150)
      
      Until ElapsedMilliseconds()>AnimEnde
      
      StartDrawing(CanvasOutput(DrawOutputID))
        ZeichneNurBrett ()
        ZeichneNurSteine (*Quelle)
        Circle(Board(Wahl)\x, Board(Wahl)\y, 9, RGB(0,200,0))
      StopDrawing()
    
    Else
      
    StartDrawing(CanvasOutput(DrawOutputID))
      ZeichneNurBrett ()
      ZeichneNurSteine (*Quelle)
    StopDrawing()    
          
    EndIf
  EndProcedure  
EndModule



; IDE Options = PureBasic 5.60 (Windows - x64)
; CursorPosition = 285
; FirstLine = 263
; Folding = --
; EnableXP